// CDirectShowUtil : DirectShow [eBeB
// ȋ@\ : tB^̗񋓂ƕѕς
// I}P : ǂgR[hstaticƂĎ
//

#include "StdAfx.h"
#include "DirectShowUtil.h"
#include <wchar.h>

#ifdef USE_MEDIA_FOUNDATION
#pragma comment(lib,"mf.lib")
#pragma comment(lib,"mfplat.lib")
#pragma comment(lib,"mfuuid.lib")
#endif

CDirectShowUtil::CDirectShowUtil(void)
	: m_FilterClassID()
{
	CoInitialize(NULL);
}

CDirectShowUtil::~CDirectShowUtil(void)
{
	CoUninitialize();
}

void CDirectShowUtil::Clear()
{
	m_FilterClassID.RemoveAll();
}

int CDirectShowUtil::GetFilterCount()
{
	return m_FilterClassID.GetCount();
}

bool CDirectShowUtil::GetFilterInfo(const int iIndex,CLSID *pidClass,wchar_t *lpwszFriendryName,int iBufLen)
{
	if(iIndex<0||iIndex>=GetFilterCount()) return false;
	DIRECTSHOW_FILTER_INFO &item = m_FilterClassID.GetAt(iIndex);
	if(pidClass) *pidClass = item.class_id;
	if(lpwszFriendryName){
		int iLen = wcslen(item.friendry_name);
		if(iLen<iBufLen){
			wcscpy_s(lpwszFriendryName,iBufLen,item.friendry_name);
			}
		}
	return true;
}

bool CDirectShowUtil::FindFilter(const CLSID *pidInType,const CLSID *pidInSubType,const CLSID *pidOutType,const CLSID *pidOutSubType)
{
	// idType idSubType ̃tB^(ϊtB^)
	bool bRet = false;
	IFilterMapper2 *pMapper=NULL;
	HRESULT hr=CoCreateInstance(CLSID_FilterMapper2,NULL, CLSCTX_INPROC, IID_IFilterMapper2,(void **) &pMapper);	
	if(SUCCEEDED(hr)) {
		IEnumMoniker *pEnum=NULL;
		GUID arInType[2],arOutType[2];
		GUID *pInTypes,*pOutTypes;
		if(pidInType)    arInType[0] = *pidInType;
		if(pidInSubType) arInType[1] = *pidInSubType;
		pInTypes = (pidInType && pidInSubType) ? arInType : NULL;
		if(pidOutType)   arOutType[0] = *pidOutType;
		if(pidOutSubType)arOutType[1] = *pidOutSubType;
		pOutTypes = (pidOutType && pidOutSubType) ? arOutType : NULL;

		hr = pMapper->EnumMatchingFilters(
			&pEnum,
			0,					// \ς
			TRUE,				// Svgp邩
			MERIT_DO_NOT_USE+1,	// ŏ̃bg
			TRUE,				// 1 ȏ̓̓s?
			pInTypes?1:0,		// ͂̃W[^Cv/Tu^Cv̑΂̐
			pInTypes,			// ͂̃W[^Cv/Tu^Cv̑΂̔z
			NULL,				// ̓fBA
			NULL,				// ̓s̃JeS
			FALSE,				// _łȂ΂ȂȂ
			TRUE,				// 1 ȏ̏o̓s
			pOutTypes?1:0,		// o͂̃W[^Cv/Tu^Cv̑΂̐
			pOutTypes,			// o͂̃W[^Cv/Tu^Cv̑΂̔z
			NULL,				// o̓fBA
			NULL);				// o̓s̃JeS
		if(SUCCEEDED(hr)){
			IMoniker *pMoniker;
			ULONG cFetched;
			while(pEnum->Next(1, &pMoniker, &cFetched) == S_OK){
				IPropertyBag *pPropBag;
				hr=pMoniker->BindToStorage(0, 0, IID_IPropertyBag, (void **)&pPropBag);
				if(SUCCEEDED(hr)){
					VARIANT varName,varID;
					VariantInit(&varName);
					VariantInit(&varID);
					hr=pPropBag->Read(L"FriendlyName", &varName, 0);
					if(SUCCEEDED(hr)){
						hr=pPropBag->Read(L"CLSID", &varID, 0);
						if(SUCCEEDED(hr)){
							bRet = true;
							DIRECTSHOW_FILTER_INFO stInfo;
							stInfo.friendry_name = varName.bstrVal;
							CLSIDFromString(varID.bstrVal,&stInfo.class_id);
							m_FilterClassID.Add(stInfo);
							SysFreeString(varID.bstrVal);
							}
							SysFreeString(varName.bstrVal);
						}
						pPropBag->Release();
					}
				}
				pEnum->Release();
			}
			pMapper->Release();
		}
	return bRet;
}

// D悷tB^Xg[ɎĂ
bool CDirectShowUtil::PriorityFilterGoToHead(const CLSID idPriorityClass)
{
	CArray<DIRECTSHOW_FILTER_INFO> Tmp;
	int i;
	for(i=0;i<m_FilterClassID.GetCount();i++){
		if(m_FilterClassID.GetAt(i).class_id == idPriorityClass) {
			// D悷̂𔭌
			Tmp.Add(m_FilterClassID.GetAt(i));
		}
	}
	if(Tmp.GetCount()==0) return false;
	for(i=0;i<m_FilterClassID.GetCount();i++){
		if(m_FilterClassID.GetAt(i).class_id != idPriorityClass) {
			// D悷̈ȊO
			Tmp.Add(m_FilterClassID.GetAt(i));
		}
	}
	m_FilterClassID.Copy(Tmp);
	return true;
}

// tB^XgI[ɎĂ
bool CDirectShowUtil::IgnoreFilterGoToTail(const CLSID idIgnoreClass,bool bRemoveIt)
{
	CArray<DIRECTSHOW_FILTER_INFO> Tmp;
	int i;
	for(i=0;i<m_FilterClassID.GetCount();i++){
		if(m_FilterClassID.GetAt(i).class_id != idIgnoreClass) {
			// ̈ȊO
			Tmp.Add(m_FilterClassID.GetAt(i));
		}
	}
	if(!bRemoveIt)
	{
		for(i=0;i<m_FilterClassID.GetCount();i++){
			if(m_FilterClassID.GetAt(i).class_id == idIgnoreClass) {
				Tmp.Add(m_FilterClassID.GetAt(i));
			}
		}
	}
	m_FilterClassID.Copy(Tmp);
	return true;
}

// Video_擾ăCX^X
bool CDirectShowUtil::CreateVideoRenderer(IBaseFilter **ppVideoRenerere, enum RendererType eRendererType,wchar_t *lpwszName, int iBufLen)
{
	IBaseFilter *pRender=NULL;
	HRESULT hr;
	wchar_t *pFilterName = L"";

	switch(eRendererType){
		case Renderer_Default:{
			// VideoRenderer
			hr = CoCreateInstance(CLSID_VideoRendererDefault, 0, CLSCTX_INPROC_SERVER, IID_IBaseFilter, (void**)&pRender);
			pFilterName = L"Video Renderer Default";
			}
			break;
		case Renderer_VMR7:{
			// VMR7
			hr = CoCreateInstance(CLSID_VideoMixingRenderer, 0, CLSCTX_INPROC, IID_IBaseFilter, (void**)&pRender);
			pFilterName = L"Video Mixing Renderer";
			}
			break;
		case Renderer_VMR9:{
			// VMR9
			hr = CoCreateInstance(CLSID_VideoMixingRenderer9, 0, CLSCTX_INPROC, IID_IBaseFilter, (void**)&pRender);
			pFilterName = L"Video Mixing Renderer 9";
			}
			break;
#ifdef USE_MEDIA_FOUNDATION
		case Renderer_EVR:{
			// EVR
			hr = CoCreateInstance(CLSID_EnhancedVideoRenderer, 0, CLSCTX_INPROC_SERVER, IID_IBaseFilter, (void**)&pRender);
			pFilterName = L"Enhanced Video Renderer(DXVA2.0)";
			if(SUCCEEDED(hr))
			{
				// Xg[̐ݒ(ftHg1)
				MF_SetNumberOfStreams(pRender);
				//
				IMFVideoDisplayControl *pVideoDisplayControl = MF_GetVideoDisplayControl(pRender);
				IMFVideoMixerControl *pVideoMixerControl = MF_GetVideoMixerControl(pRender);
				SAFE_RELEASE(pVideoDisplayControl);
				SAFE_RELEASE(pVideoMixerControl);
			}
			}
			break;
#endif			
		default:{
			// _Ȃ
			return false;
			}
			break;
	}
	if(SUCCEEDED(hr)){
		if(ppVideoRenerere){
			// ߂lݒ
			*ppVideoRenerere = pRender;
			} else {
			// ߂AhXȂ̂ŉ
			pRender->Release();
			}
		if(lpwszName&&iBufLen>0){
			// tB^Ԃ
			int iLen = wcslen(pFilterName);
			if(iLen<iBufLen){
				wcscpy_s(lpwszName, iBufLen , pFilterName);
				}
			}
		return true;
		} else {
		return false;
		}
}

// tB^w胁fBÃs
IPin* CDirectShowUtil::GetFilterPin(IBaseFilter *pFilter, const PIN_DIRECTION dir, const AM_MEDIA_TYPE *pMediaType)
{
	IEnumPins *pEnumPins=NULL;
	IPin *pPin;
	IPin *pRetPin=NULL;

	if(pFilter->EnumPins(&pEnumPins)==S_OK ){
		ULONG cFetched;
		while(!pRetPin&&pEnumPins->Next(1,&pPin,&cFetched)==S_OK){
			PIN_INFO stPin;
			if(pPin->QueryPinInfo(&stPin)==S_OK){				
				if(stPin.dir==dir){
					if(!pMediaType){
						// ĂOK
						pRetPin=pPin;						
						pRetPin->AddRef();
						} else {
						// DirectShowɂ܂ăs
						if(pPin->QueryAccept(pMediaType)==S_OK){
							pRetPin=pPin;
							pRetPin->AddRef();
							}	
						}
					}
					if(stPin.pFilter) stPin.pFilter->Release();
				}
				pPin->Release();				
			}
		pEnumPins->Release();
		}
	return pRetPin;
}

// tB^̃vpeBy[WJ
bool CDirectShowUtil::ShowPropertyPage(IBaseFilter *pFilter, HWND hWndParent)
{
	bool bRet = false;
	FILTER_INFO stFilterInfo;
	ISpecifyPropertyPages *pProp = NULL;
	IUnknown *pFilterUnk=NULL;;
	if(pFilter){
		HRESULT hr = pFilter->QueryInterface(IID_ISpecifyPropertyPages, (void **)&pProp);
		if(SUCCEEDED(hr)){			
			CAUUID caGUID;
			pProp->GetPages(&caGUID);
			SAFE_RELEASE(pProp);
			hr = pFilter->QueryFilterInfo(&stFilterInfo);
			if(SUCCEEDED(hr)){				
				hr = pFilter->QueryInterface(IID_IUnknown, (void **)&pFilterUnk);
				if(SUCCEEDED(hr)){
					OleCreatePropertyFrame(
						hWndParent,             // eEBhEB
						0, 0,                   // \ς݁B
						stFilterInfo.achName,   // _CAO {bNX̃LvVB
						1,                      // IuWFNg (tB^̂)B
						&pFilterUnk,            // IuWFNg |C^̔zB
						caGUID.cElems,          // vpeB y[WB
						caGUID.pElems,          // vpeB y[W CLSID ̔zB
						0,                      // P[ʎqB
						0, NULL                 // \ς݁B
					);
					CoTaskMemFree(caGUID.pElems);
					SAFE_RELEASE(pFilterUnk);
					bRet = true;
					}
				SAFE_RELEASE(stFilterInfo.pGraph);
				}
			}
		}
	return bRet;
}


// MpegfR[_ǉăsڑsB
// pUtilɐς݃fR[_񋓂ĂƂ̐񏇂ɐڑsBNULLȂftHgB
//   킴킴w肷闝R : ̃NXɌꂽtB^Mpeg2̂̂Ƃ͌ȂׁB
//
// ppMpeg2DecoderFilter ͐ڑɎgꂽMpeg2C^[tF[X󂯂ƂB
// ppCurrentOutputPin 㗬ɐڑꂽLȃsł̂OB
// ppCurrentOutputPin ͐IȂAfR[_tB^̏o̓s*ppNewOutputPinɂȂB
// ppNewOutputPin==NULL ̏ꍇAfR[_tB^̏o̓s*ppCurrentOutputPinɂȂB*ppCurrentOutputPin͉
//
// sꍇłtB^͍sȂpX(ɐڑς݂̏ꍇ)B߂tB^͊mFĉ邱
bool CDirectShowUtil::AppendMpeg2Decoder_and_Connect(IGraphBuilder *pFilterGraph, CDirectShowUtil *pUtil, IBaseFilter **ppMpeg2DecoderFilter,wchar_t *lpszDecoderName,int iDecNameBufLen, IPin **ppCurrentOutputPin, IPin **ppNewOutputPin)
{
	HRESULT hr;
	IPin *pInput = NULL;
	CDirectShowUtil cUtil;	
	CLSID guidFilter = CLSID_NULL;
	bool bRet;
	wchar_t tmp[128];
	if(!lpszDecoderName){
		lpszDecoderName = tmp;
		iDecNameBufLen = 128;
		}

	// |C^`FbN
	if(!pFilterGraph || !ppMpeg2DecoderFilter || !ppCurrentOutputPin) return false;
	// sAhXȂ New==NULL œ͂ꂽ̂Ɠ`
	if(ppCurrentOutputPin==ppNewOutputPin) ppNewOutputPin = NULL;
	// w肪Ȃꍇ̃tB^
	if(!pUtil){
		pUtil = &cUtil;
		if(!pUtil->FindFilter(&MEDIATYPE_Video,&MEDIASUBTYPE_MPEG2_VIDEO)) return false;
		}
	// ߂lNA
	*ppMpeg2DecoderFilter = NULL;

	bRet=false;
	for(int i=0;!bRet&&i<pUtil->GetFilterCount();i++){
		if(!pUtil->GetFilterInfo(i,&guidFilter,lpszDecoderName,iDecNameBufLen)) continue;
		hr = ::CoCreateInstance(guidFilter, NULL, CLSCTX_INPROC_SERVER, IID_IBaseFilter, (void**)ppMpeg2DecoderFilter);
		if(FAILED(hr)) continue;
		hr = pFilterGraph->AddFilter(*ppMpeg2DecoderFilter,lpszDecoderName);
		if(FAILED(hr)){
			SAFE_RELEASE(*ppMpeg2DecoderFilter);
			continue;
			}
		pInput = CDirectShowUtil::GetFilterPin(*ppMpeg2DecoderFilter,PINDIR_INPUT);
		if(!pInput){
			SAFE_RELEASE(*ppMpeg2DecoderFilter);
			continue;
		}
		hr = pFilterGraph->Connect(*ppCurrentOutputPin,pInput);
		if(FAILED(hr)){
			SAFE_RELEASE(pInput);
			pFilterGraph->RemoveFilter(*ppMpeg2DecoderFilter);			
			SAFE_RELEASE(*ppMpeg2DecoderFilter);
			continue;
		} else {
			bRet=true;
		}
		}
	if(!bRet) {
		// Sgݍ킹œKfR[_
		return false;
	}
	// ڑɎgs
	SAFE_RELEASE(*ppCurrentOutputPin);
	SAFE_RELEASE(pInput);
	// tB^ւ̏o̓sT
	IPin *pNewOutput = GetFilterPin(*ppMpeg2DecoderFilter, PINDIR_OUTPUT);
	if(!pNewOutput){
		// o̓sȂ
		return false;
		}
	if(ppNewOutputPin){
		// Vo̓sɏo
		// ̏o̓s͊ɉς
		*ppNewOutputPin = pNewOutput;
		}else{
		// o̓sXV(ppCurrentOutputPin==ppNewOutputPin̏ꍇł̂㏑XVƂȂ)
		// ̏o̓s͊ɉς
		*ppCurrentOutputPin = pNewOutput;
		}
	return true;
}

// wtB^oRăsڑs(ɓ=1/o=1̌oR^tB^ڑp)
// Filterw
//
// lpwszFilterName  NULL łǂB
// ppCurrentOutputPin 㗬ɐڑꂽLȃsł̂OB
// ppCurrentOutputPin ͐IȂAFԕϊtB^̏o̓s*ppNewOutputPinɂȂB
// ppNewOutputPin==NULL ̏ꍇAtB^̏o̓s*ppCurrentOutputPinɂȂB*ppCurrentOutputPin͉
//
// sꍇłtB^͍sȂpX(ɐڑς݂̏ꍇ)B߂tB^͊mFĉ邱
bool CDirectShowUtil::AppendFilter_and_Connect(IBaseFilter *pFilter,const wchar_t *lpwszFilterName, IGraphBuilder *pFilterGraph, IPin **ppCurrentOutputPin, IPin **ppNewOutputPin)
{
	HRESULT hr;
	IPin *pInput = NULL;
	UINT refCount;
	// |C^`FbN
	if(!pFilterGraph || !pFilter || !ppCurrentOutputPin) return false;
	// sAhXȂ New==NULL œ͂ꂽ̂Ɠ`
	if(ppCurrentOutputPin==ppNewOutputPin) ppNewOutputPin = NULL;

	if(!lpwszFilterName) lpwszFilterName = L"No Name";
	hr = pFilterGraph->AddFilter(pFilter, lpwszFilterName);
	if(FAILED(hr)){
		// tB^ɒǉs
		return false;
		}
	pInput = GetFilterPin(pFilter, PINDIR_INPUT);
	if(!pInput){
		// ̓sȂ
		return false;
		}
	// ڑ
	hr = pFilterGraph->Connect(*ppCurrentOutputPin,pInput);
	if(FAILED(hr)){
		// ڑłȂ
		SAFE_RELEASE(pInput);
		pFilterGraph->RemoveFilter(pFilter);
		return false;
		}
	// ڑɎgs
	SAFE_RELEASE(*ppCurrentOutputPin);
	SAFE_RELEASE(pInput);
	// tB^ւ̏o̓sT(o̓sĂ͑s)
	IPin *pNewOutput = GetFilterPin(pFilter, PINDIR_OUTPUT);
	if(ppNewOutputPin){
		// Vo̓sɏo
		// ̏o̓s͊ɉς
		*ppNewOutputPin = pNewOutput;
		}else{
		// o̓sXV(ppCurrentOutputPin==ppNewOutputPin̏ꍇł̂㏑XVƂȂ)
		// ̏o̓s͊ɉς
		*ppCurrentOutputPin = pNewOutput;
		}
#ifdef _DEBUG
	refCount = GetRefCount(pFilter);
#endif
	return true;
}

// wtB^oRăsڑs(ɓ=1/o=1̌oR^tB^ڑp)
// CLSIDw
//
// AppendFilter_and_Connect(Filterw)̐QƁB
// guidFilter͗LDirectShowtB^GUIDw肷B
// ppAppendedFilter ͒ǉtB^󂯎B
bool CDirectShowUtil::AppendFilter_and_Connect(const CLSID guidFilter,const wchar_t *lpwszFilterName, IGraphBuilder *pFilterGraph, IBaseFilter **ppAppendedFilter, IPin **ppCurrentOutputPin, IPin **ppNewOutputPin)
{
	// tB^CX^X쐬
	HRESULT hr = ::CoCreateInstance(guidFilter, NULL, CLSCTX_INPROC_SERVER, IID_IBaseFilter, (void**)(ppAppendedFilter));
	if(FAILED(hr)) {
		// CX^X쐬s
		return false;
		}
	bool bRet = AppendFilter_and_Connect(*ppAppendedFilter,lpwszFilterName,pFilterGraph,ppCurrentOutputPin,ppNewOutputPin);
	if(!bRet){
		SAFE_RELEASE(*ppAppendedFilter);
		return false;
		}
	return true;
}

// FԕϊtB^oRăsڑs(GtFNgtB^ւ̑Ή̂߂̐FԕϊKvȏꍇ̂)
//
// AppendFilter_and_Connect(Filterw)̐Q
// ppColorSpaceConverterFilter ͒ǉtB^󂯎ׂ̃|C^
bool CDirectShowUtil::AppendColorSpaceConverterFilter_and_Connect(IGraphBuilder *pFilterGraph, IBaseFilter **ppColorSpaceConverterFilter, IPin **ppCurrentOutputPin, IPin **ppNewOutputPin)
{
	return AppendFilter_and_Connect(CLSID_ColorSpaceConverter,L"Color Space Converter",pFilterGraph,ppColorSpaceConverterFilter,ppCurrentOutputPin,ppNewOutputPin);
}

// _̏o͐rfIEBhẼC^[tF[X擾
// EVRgpMF_GetVideoDisplayControl()g
IVideoWindow* CDirectShowUtil::GetVideoWindow(IGraphBuilder *pGraph)
{
	IVideoWindow *pVideoWindow;
	HRESULT hr = pGraph->QueryInterface(IID_IVideoWindow,(void**)&pVideoWindow);
	if(SUCCEEDED(hr)){
		return pVideoWindow;
		}
	return NULL;
}

IBasicVideo2* CDirectShowUtil::GetBasicVideo2(IGraphBuilder *pGraph)
{
	IBasicVideo2 *pBasicVideo;
	HRESULT hr = pGraph->QueryInterface(IID_IBasicVideo,(void**)&pBasicVideo);
	if(SUCCEEDED(hr)){
		return pBasicVideo;
		}
	return NULL;
}

IMediaControl* CDirectShowUtil::GetMediaControl(IGraphBuilder *pGraph)
{
	IMediaControl *pMediaControl;
	HRESULT hr = pGraph->QueryInterface(IID_IMediaControl,(void**)&pMediaControl);
	if(SUCCEEDED(hr)){
		return pMediaControl;
		}
	return NULL;
}

// w肵rfItB^̃_𔻒f
CDirectShowUtil::RendererType CDirectShowUtil::GetVideoRendererType(IBaseFilter *pVideoRenderer)
{
	CLSID guid;
	RendererType ret = CDirectShowUtil::Renderer_Unknown;
	if(SUCCEEDED(pVideoRenderer->GetClassID(&guid))){
		if(IsEqualGUID(guid,CLSID_VideoRendererDefault)){
			ret = CDirectShowUtil::Renderer_Default;
			} else if(IsEqualGUID(guid,CLSID_VideoMixingRenderer)){
			ret = CDirectShowUtil::Renderer_VMR7;
			} else if(IsEqualGUID(guid,CLSID_VideoMixingRenderer9)){
			ret = CDirectShowUtil::Renderer_VMR9;
			} else if(IsEqualGUID(guid,CLSID_EnhancedVideoRenderer)){
			ret = CDirectShowUtil::Renderer_EVR;
			}
		}
	return ret;
}

//////////////////////////////////////////////////////////////////////
// ȉ EVRp[eBeB

#ifdef USE_MEDIA_FOUNDATION

// EVRp : 
void CDirectShowUtil::MF_Init()
{
	::MFStartup(MF_VERSION);
};

// EVRp : I
void CDirectShowUtil::MF_Term() {
	::MFShutdown();
};

// EVRp : EVRݒpC^[tF[X̎擾
IEVRFilterConfig* CDirectShowUtil::MF_GetEVRFilterConfig(IBaseFilter *pEvr)
{
	IEVRFilterConfig *pEvrFilterConfig;
	HRESULT hr = pEvr->QueryInterface(IID_IEVRFilterConfig,(void**)&pEvrFilterConfig);
	if(SUCCEEDED(hr)) {
		return pEvrFilterConfig;
		}
	return NULL;
}

// EVRp : EVRMF̃T[rX擾pC^[tF[X̎擾
IMFGetService* CDirectShowUtil::MF_GetService(IBaseFilter *pEvr)
{
	IMFGetService *pMFGetService;
	HRESULT hr = pEvr->QueryInterface(IID_IMFGetService,(void**)&pMFGetService);
	if(SUCCEEDED(hr)) {
		return pMFGetService;
		}
	return NULL;
}

// EVRp : ̓Xg[ݒ肷iʏ͂Pj
bool CDirectShowUtil::MF_SetNumberOfStreams(IBaseFilter *pEvr,int iStreamNumber)
{
	IEVRFilterConfig *pFilterConfig = MF_GetEVRFilterConfig(pEvr);
	if(pFilterConfig) {
		pFilterConfig->SetNumberOfStreams(iStreamNumber);
		SAFE_RELEASE(pFilterConfig);
		return true;
		}
	return false;
}

// EVRp : fBXvCpC^[tF[X̎擾
IMFVideoDisplayControl* CDirectShowUtil::MF_GetVideoDisplayControl(IBaseFilter *pEvr)
{
	IMFGetService *pService = MF_GetService(pEvr);
	if(pService) {
		IMFVideoDisplayControl *pDisplayControl;
		HRESULT hr = pService->GetService(MR_VIDEO_RENDER_SERVICE,IID_IMFVideoDisplayControl,(void**)&pDisplayControl);
		SAFE_RELEASE(pService);
		if(SUCCEEDED(hr)){
			return pDisplayControl;
			}
		}
	return NULL;
}

// EVRp : rfI~LTpC^[tF[X̎擾
IMFVideoMixerControl* CDirectShowUtil::MF_GetVideoMixerControl(IBaseFilter *pEvr)
{
	IMFGetService *pService = MF_GetService(pEvr);
	if(pService) {
		IMFVideoMixerControl *pVideoMixerControl;
		HRESULT hr = pService->GetService(MR_VIDEO_MIXER_SERVICE,IID_IMFVideoMixerControl,(void**)&pVideoMixerControl);
		SAFE_RELEASE(pService);
		if(SUCCEEDED(hr)) {
			return pVideoMixerControl;
			}
		}
	return NULL;
}

// EVRp : rfIvZbTpC^[tF[X̎擾
IMFVideoProcessor* CDirectShowUtil::MF_GetVideoProcessor(IBaseFilter *pEvr)
{
	IMFGetService *pService = MF_GetService(pEvr);
	if(pService) {
		IMFVideoProcessor *pVideoProcessor;
		HRESULT hr = pService->GetService(MR_VIDEO_MIXER_SERVICE,IID_IMFVideoProcessor,(void**)&pVideoProcessor);
		SAFE_RELEASE(pService);
		if(SUCCEEDED(hr)) {
			return pVideoProcessor;
			}
		}
	return NULL;
}

#endif